> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/bmc/cidr-block/describecidrblocks.md).

# DescribeCidrBlocks

## 1. API Description

This API (DescribeCidrBlocks) is used to query the details of CIDR blocks.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type                                                         | Description                                                                                                              |
| --------------- | -------- | ------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------ |
| cidrBlockIds    | No       | Array of String                                              | <p>IDs of the CIDR blocks.</p><p>You can query up to 100 CIDR blocks in each request.</p>                                |
| cidrBlock       | No       | String                                                       | IP range of CIDR block.                                                                                                  |
| cidrBlockName   | No       | String                                                       | Name of CIDR block.                                                                                                      |
| zoneId          | No       | String                                                       | Zone ID to which the CIDR blocks belong.                                                                                 |
| cidrBlockType   | No       | [IpType](/api-reference/bmc/datastructure.md#iptype)         | <p>Type of CIDR block. The optional values are as follows:</p><p>IPv4 IPv6</p>                                           |
| gateway         | No       | String                                                       | IP address of the gateway.                                                                                               |
| chargeType      | No       | [ChargeType](/api-reference/bmc/datastructure.md#chargetype) | <p>CIDR block pricing model .</p><p>PREPAID: subscription POSTPAID: pay-as-you-go</p>                                    |
| resourceGroupId | No       | String                                                       | <p>Resource group ID.</p><p>If the value is null, then return all the CIDR blocks in the authorized resource groups.</p> |
| pageNum         | No       | Integer                                                      | <p>Number of pages returned.</p><p>Default value: 1.</p><p>Default value: 1</p>                                          |
| pageSize        | No       | Integer                                                      | <p>Number of items in the current page result.</p><p>Default value: 20;</p><p>Maximum value: 1000.</p>                   |
| tagKeys         | No       | Array of String                                              | <p>Query according to tag key.</p><p>You can query up to 20 tag keys in each request.</p>                                |
| tags            | No       | Array of [Tag](/api-reference/bmc/datastructure.md#tag)      | <p>Query according to tag.</p><p>You can query up to 20 tags in each request.</p>                                        |

## 3. Output Parameters

| Parameter Name | Type                                                                        | Description                                                                                                           |
| -------------- | --------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                      | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| totalCount     | Integer                                                                     | Number of CIDR blocks meeting the filtering conditions.                                                               |
| dataSet        | Array of [CidrBlockInfo](/api-reference/bmc/datastructure.md#cidrblockinfo) | Information on a CIDR block.                                                                                          |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeCidrBlocks
<Common Request Params>

Request:
{
  "pageNum": 1,
  "pageSize": 1
}

Response:
{
  "requestId": "T9731D74B-4EA3-498E-AC75-4C036ABAF598",
  "response": {
    "requestId": "T9731D74B-4EA3-498E-AC75-4C036ABAF598",
    "totalCount": 14,
    "dataSet": [
      {
        "cidrBlockId": "767715590704998412",
        "cidrBlockType": "IPV4",
        "cidrBlockName": "mycidrblock",
        "zoneId": "CHI-A",
        "cidrBlock": "1.1.218.184/29",
        "gateway": "1.1.218.185",
        "availableIpStart": "1.1.218.186",
        "availableIpEnd": "1.1.218.190",
        "availableIpCount": 5,
        "instanceIds": [
          "780812773306141196"
        ],
        "status": "RECYCLE",
        "chargeType": "POSTPAID",
        "createTime": "2022-11-25T05:53:50Z",
        "expireTime": "2022-11-25T08:00:42Z",
        "resourceGroupId": "5eab5afc-88a2-46a9-bad3-278df7069f13",
        "resourceGroupName": "Default Resource Group"
      }
    ]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                | Description     |
| ---------------- | ------------------------- | --------------- |
| 404              | INVALID\_ZONE\_NOT\_FOUND | Zone not found. |
